% \documentclass[noanswers, nolegalese, 11pt]{examjh}
\documentclass[answers, nolegalese]{examjh}
\usepackage{../../../computingfonts}
\usepackage{../../../contentmacros}

\setlength{\parindent}{0em}\setlength{\parskip}{0.5ex}
\begin{document}\thispagestyle{empty}
\makebox[\textwidth]{\sc MA 208, Theory of Computation\hfill  Hand-in\hfill Due: 2021-Feb-01}
\vspace*{1ex}
\begin{center}
 \parbox{0.95\textwidth}{\textit{
  The work that you hand in must be entirely your own. 
  When you write this document, you may not work with anyone else,
  or copy material from the Internet, etc.
  You are of course allowed to use any materials from the class, including
  the text, or the notes or discussions.
  }}
\end{center}
\vspace*{1ex}
\begin{questions}
\question
Write a Turing machine that computes this function.
Use $\Sigma=\set{\str{B},\str{1}}$, and use
unary representation, with the machine head at 
the leftmost character of the input string at the start, and at
the leftmost character when the machine stops.
\begin{equation*}
  f(x)=
  \begin{cases}
    1  &\case{if $x$ is even}  \\
    0  &\case{otherwise}
  \end{cases}
\end{equation*}
An output is $1$ means the tape has a single \str{1} and the head points to
it, while an output of $0$ means that the tape is entirely blank.
\begin{solution}
There are many solutions, but this is one.
\begin{equation*}
  \TM=\set{\tminstruction{0}{B}{B}{4},\,
  \tminstruction{0}{1}{B}{1},\,
  \tminstruction{1}{B}{R}{2},\,
  \tminstruction{2}{B}{B}{5},\,
  \tminstruction{2}{1}{B}{3},\,
  \tminstruction{3}{B}{R}{0},\,
  \tminstruction{4}{B}{1}{5}}
\end{equation*}
The strategy is to blank out pairs of \str{1}'s, in $q_0$ and~$q_2$, and then
after looping on that until there are no more \str{1}'s, either put out
a \str{1} (if there were an even number) or just leave the tape blank.
\end{solution}
% 0 B B 4
% 0 1 B 1
% 1 B R 2
% 2 B B 5
% 2 1 B 3
% 3 B R 0
% 4 B 1 5

\question
Briefly rebut this: ``A Turing machine has an infinite tape 
but no actual computer
has an infinite tape, so Turing machines are unrealistic.''
\begin{solution}
Actually, we can avoid infinite by taking the tape to be unbounded.
But perhaps there is an objection to unbounded storage. 

Turing machines are an idealization of a physically-realizable
discrete and deterministic computer.
They allow us to study what is computable in principle.
In particular, if we show that something cannot be computed by 
a Turing machine then it cannot be computed by any 
physical device.
\end{solution}
\end{questions}
\end{document}